import pendulum

from resa_padel.gestion_sports.gestion_sports_payload_builder import (
    GestionSportsPayloadBuilder,
)


def test_login_payload_should_be_built():
    payload_builder = GestionSportsPayloadBuilder()
    login = "jacques"
    password = "chirac"
    club_id = "27"
    login_payload = (
        payload_builder.login(login)
        .password(password)
        .club_id(club_id)
        .build_login_payload()
    )

    assert login_payload == (
        f"ajax=connexionUser&id_club={club_id}&email={login}&form_ajax=1&pass={password}&compte"
        f"=user&playeridonesignal=0&identifiant=identifiant&externCo=true"
    ).encode("utf-8")


def test_booking_payload_should_be_built():
    booking_builder = GestionSportsPayloadBuilder()
    booking_date = pendulum.now("Europe/Paris")
    sport_id = "27"
    court_id = "55"
    booking_payload = (
        booking_builder.date(booking_date.date())
        .time(booking_date.time())
        .sport_id(sport_id)
        .court_id(court_id)
        .build_booking_payload()
    )

    assert booking_payload == (
        f"ajax=addResa&date={booking_date.date()}&hour={booking_date.time()}&duration=90"
        f"&partners=null|null|null&paiement=facultatif&idSport={sport_id}"
        f"&creaPartie=false&idCourt={court_id}&pay=false&token=undefined&totalPrice=44&saveCard=0"
        f"&foodNumber=0"
    ).encode("utf-8")
